A couple of fixes to fix build against current rpm.org head
authorPanu Matilainen <pmatilai@laiskiainen.org>
Sun, 23 Sep 2007 13:09:13 +0000 (16:09 +0300)
committerPanu Matilainen <pmatilai@laiskiainen.org>
Sun, 23 Sep 2007 13:09:13 +0000 (16:09 +0300)
Patch from Ralf Corsepius

apt-pkg/rpm/rpmpm.cc
apt-pkg/rpm/rpmsystem.cc
apt-pkg/rpm/rpmversion.cc
buildlib/config.h.in
configure
configure.ac

index 99de1ee..59f72d8 100644 (file)
 #include <stdio.h>
 #include <iostream>
 
+#if HAVE_RPM_RPMSX_H
+#include <rpm/rpmsx.h
+#endif
+
 #if RPM_VERSION >= 0x040100
 #include <rpm/rpmdb.h>
 #else
@@ -789,7 +793,7 @@ bool pkgRPMLibPM::Process(vector<const char*> &install,
       tsFlags |= RPMTRANS_FLAG_REPACKAGE;
 #endif
                     
-#if RPM_VERSION >= 0x040300
+#if HAVE_RPM_RPMSX_H
 #ifdef WITH_SELINUX
    /* Initialize security context patterns for SELinux */
    if (!(tsFlags & RPMTRANS_FLAG_NOCONTEXTS)) {
index 9dcc000..94634d0 100644 (file)
@@ -42,7 +42,7 @@
                                                                        /*}}}*/
 // for distrover
 #if RPM_VERSION >= 0x040101
-#include <rpmdb.h>
+#include <rpm/rpmdb.h>
 #endif
 
 #if RPM_VERSION >= 0x040201
index 9338d41..511cc9c 100644 (file)
@@ -23,7 +23,9 @@
 #include <apt-pkg/pkgcache.h>
 
 #include <rpm/rpmlib.h>
+#if HAVE_RPM_MISC_H
 #include <rpm/misc.h>
+#endif
 
 #include <stdlib.h>
 #include <assert.h>
index 0930efa..c418301 100644 (file)
 /* Define if RPM backend is available */
 #undef HAVE_RPM
 
+/* Define to 1 if you have the <rpm/misc.h> header file. */
+#undef HAVE_RPM_MISC_H
+
+/* Define to 1 if you have the <rpm/rpmsx.h> header file. */
+#undef HAVE_RPM_RPMSX_H
+
 /* Define to 1 if you have the <stdint.h> header file. */
 #undef HAVE_STDINT_H
 
index 5751d47..1de2723 100755 (executable)
--- a/configure
+++ b/configure
@@ -21592,7 +21592,6 @@ fi
 done
 
 
-   CPPFLAGS="$CPPFLAGS -I/usr/include/rpm"
    if test "${ac_cv_header_rpm_rpmlib_h+set}" = set; then
   { echo "$as_me:$LINENO: checking for rpm/rpmlib.h" >&5
 echo $ECHO_N "checking for rpm/rpmlib.h... $ECHO_C" >&6; }
 
 
 
+
+for ac_header in rpm/rpmsx.h rpm/misc.h
+do
+as_ac_Header=`echo "ac_cv_header_$ac_header" | $as_tr_sh`
+if { as_var=$as_ac_Header; eval "test \"\${$as_var+set}\" = set"; }; then
+  { echo "$as_me:$LINENO: checking for $ac_header" >&5
+echo $ECHO_N "checking for $ac_header... $ECHO_C" >&6; }
+if { as_var=$as_ac_Header; eval "test \"\${$as_var+set}\" = set"; }; then
+  echo $ECHO_N "(cached) $ECHO_C" >&6
+fi
+ac_res=`eval echo '${'$as_ac_Header'}'`
+              { echo "$as_me:$LINENO: result: $ac_res" >&5
+echo "${ECHO_T}$ac_res" >&6; }
+else
+  # Is the header compilable?
+{ echo "$as_me:$LINENO: checking $ac_header usability" >&5
+echo $ECHO_N "checking $ac_header usability... $ECHO_C" >&6; }
+cat >conftest.$ac_ext <<_ACEOF
+/* confdefs.h.  */
+_ACEOF
+cat confdefs.h >>conftest.$ac_ext
+cat >>conftest.$ac_ext <<_ACEOF
+/* end confdefs.h.  */
+$ac_includes_default
+#include <$ac_header>
+_ACEOF
+rm -f conftest.$ac_objext
+if { (ac_try="$ac_compile"
+case "(($ac_try" in
+  *\"* | *\`* | *\\*) ac_try_echo=\$ac_try;;
+  *) ac_try_echo=$ac_try;;
+esac
+eval "echo \"\$as_me:$LINENO: $ac_try_echo\"") >&5
+  (eval "$ac_compile") 2>conftest.er1
+  ac_status=$?
+  grep -v '^ *+' conftest.er1 >conftest.err
+  rm -f conftest.er1
+  cat conftest.err >&5
+  echo "$as_me:$LINENO: \$? = $ac_status" >&5
+  (exit $ac_status); } && {
+        test -z "$ac_c_werror_flag" ||
+        test ! -s conftest.err
+       } && test -s conftest.$ac_objext; then
+  ac_header_compiler=yes
+else
+  echo "$as_me: failed program was:" >&5
+sed 's/^/| /' conftest.$ac_ext >&5
+
+       ac_header_compiler=no
+fi
+
+rm -f core conftest.err conftest.$ac_objext conftest.$ac_ext
+{ echo "$as_me:$LINENO: result: $ac_header_compiler" >&5
+echo "${ECHO_T}$ac_header_compiler" >&6; }
+
+# Is the header present?
+{ echo "$as_me:$LINENO: checking $ac_header presence" >&5
+echo $ECHO_N "checking $ac_header presence... $ECHO_C" >&6; }
+cat >conftest.$ac_ext <<_ACEOF
+/* confdefs.h.  */
+_ACEOF
+cat confdefs.h >>conftest.$ac_ext
+cat >>conftest.$ac_ext <<_ACEOF
+/* end confdefs.h.  */
+#include <$ac_header>
+_ACEOF
+if { (ac_try="$ac_cpp conftest.$ac_ext"
+case "(($ac_try" in
+  *\"* | *\`* | *\\*) ac_try_echo=\$ac_try;;
+  *) ac_try_echo=$ac_try;;
+esac
+eval "echo \"\$as_me:$LINENO: $ac_try_echo\"") >&5
+  (eval "$ac_cpp conftest.$ac_ext") 2>conftest.er1
+  ac_status=$?
+  grep -v '^ *+' conftest.er1 >conftest.err
+  rm -f conftest.er1
+  cat conftest.err >&5
+  echo "$as_me:$LINENO: \$? = $ac_status" >&5
+  (exit $ac_status); } >/dev/null && {
+        test -z "$ac_c_preproc_warn_flag$ac_c_werror_flag" ||
+        test ! -s conftest.err
+       }; then
+  ac_header_preproc=yes
+else
+  echo "$as_me: failed program was:" >&5
+sed 's/^/| /' conftest.$ac_ext >&5
+
+  ac_header_preproc=no
+fi
+
+rm -f conftest.err conftest.$ac_ext
+{ echo "$as_me:$LINENO: result: $ac_header_preproc" >&5
+echo "${ECHO_T}$ac_header_preproc" >&6; }
+
+# So?  What about this header?
+case $ac_header_compiler:$ac_header_preproc:$ac_c_preproc_warn_flag in
+  yes:no: )
+    { echo "$as_me:$LINENO: WARNING: $ac_header: accepted by the compiler, rejected by the preprocessor!" >&5
+echo "$as_me: WARNING: $ac_header: accepted by the compiler, rejected by the preprocessor!" >&2;}
+    { echo "$as_me:$LINENO: WARNING: $ac_header: proceeding with the compiler's result" >&5
+echo "$as_me: WARNING: $ac_header: proceeding with the compiler's result" >&2;}
+    ac_header_preproc=yes
+    ;;
+  no:yes:* )
+    { echo "$as_me:$LINENO: WARNING: $ac_header: present but cannot be compiled" >&5
+echo "$as_me: WARNING: $ac_header: present but cannot be compiled" >&2;}
+    { echo "$as_me:$LINENO: WARNING: $ac_header:     check for missing prerequisite headers?" >&5
+echo "$as_me: WARNING: $ac_header:     check for missing prerequisite headers?" >&2;}
+    { echo "$as_me:$LINENO: WARNING: $ac_header: see the Autoconf documentation" >&5
+echo "$as_me: WARNING: $ac_header: see the Autoconf documentation" >&2;}
+    { echo "$as_me:$LINENO: WARNING: $ac_header:     section \"Present But Cannot Be Compiled\"" >&5
+echo "$as_me: WARNING: $ac_header:     section \"Present But Cannot Be Compiled\"" >&2;}
+    { echo "$as_me:$LINENO: WARNING: $ac_header: proceeding with the preprocessor's result" >&5
+echo "$as_me: WARNING: $ac_header: proceeding with the preprocessor's result" >&2;}
+    { echo "$as_me:$LINENO: WARNING: $ac_header: in the future, the compiler will take precedence" >&5
+echo "$as_me: WARNING: $ac_header: in the future, the compiler will take precedence" >&2;}
+    ( cat <<\_ASBOX
+## -------------------------------------------- ##
+## Report this to apt-rpm@lists.laiskiainen.org ##
+## -------------------------------------------- ##
+_ASBOX
+     ) | sed "s/^/$as_me: WARNING:     /" >&2
+    ;;
+esac
+{ echo "$as_me:$LINENO: checking for $ac_header" >&5
+echo $ECHO_N "checking for $ac_header... $ECHO_C" >&6; }
+if { as_var=$as_ac_Header; eval "test \"\${$as_var+set}\" = set"; }; then
+  echo $ECHO_N "(cached) $ECHO_C" >&6
+else
+  eval "$as_ac_Header=\$ac_header_preproc"
+fi
+ac_res=`eval echo '${'$as_ac_Header'}'`
+              { echo "$as_me:$LINENO: result: $ac_res" >&5
+echo "${ECHO_T}$ac_res" >&6; }
+
+fi
+if test `eval echo '${'$as_ac_Header'}'` = yes; then
+  cat >>confdefs.h <<_ACEOF
+#define `echo "HAVE_$ac_header" | $as_tr_cpp` 1
+_ACEOF
+
+fi
+
+done
+
+
    if test $RPM_VERSION_MAJOR -lt 4; then
       RPMLIBS="-lrpm -lz -lbz2 -lpopt"
    else
index 1394996..dc2bead 100644 (file)
@@ -74,9 +74,9 @@ else
                [AC_MSG_ERROR([Can't find libz library])])
    AC_CHECK_HEADERS(db1/db.h)
 
-   CPPFLAGS="$CPPFLAGS -I/usr/include/rpm"
    AC_CHECK_HEADER(rpm/rpmlib.h, [],
                   [AC_MSG_ERROR([Can't find rpmlib.h])])
+   AC_CHECK_HEADERS([rpm/rpmsx.h rpm/misc.h])
 
    if test $RPM_VERSION_MAJOR -lt 4; then
       RPMLIBS="-lrpm -lz -lbz2 -lpopt"